【LeetCode】零钱兑换 [M](动态规划)
·
一、题目
给你一个整数数组 coins ,表示不同面额的硬币;以及一个整数 amount ,表示总金额。
计算并返回可以凑成总金额所需的 最少的硬币个数 。如果没有任何一种硬币组合能组成总金额,返回 -1 。
你可以认为每种硬币的数量是无限的。
示例 1:
输入:coins = [1, 2, 5], amount = 11 输出:3 解释:11 = 5 + 5 + 1
示例 2:
输入:coins = [2], amount = 3 输出:-1
示例 3:
输入:coins = [1], amount = 0 输出:0
提示:
1 <= coins.length <= 121 <= coins[i] <= 231 - 10 <= amount <= 104
二、代码
class Solution {
public int coinChange(int[] arr, int aim) {
if (aim == 0) {
return 0;
}
int N = arr.length;
int[][] dp = new int[N + 1][aim + 1];
dp[N][0] = 0;
for (int j = 1; j <= aim; j++) {
dp[N][j] = Integer.MAX_VALUE;
}
for (int index = N - 1; index >= 0; index--) {
for (int rest = 0; rest <= aim; rest++) {
// 根据严格位置依赖关系,去进行斜率优化。这个通过画图能很直观的找到优化的方法,可以将枚举过程省略掉
// 先将要赋值位置的值设置为其正下方位置的值,用来后续和其他依赖位置的值比较取最小值
dp[index][rest] = dp[index + 1][rest];
// 去判断dp[index][rest]左边位置dp[index][rest - arr[index]]是否符合我们要判断的要求
// 需要rest - arr[index] >=0,因为数组下标不能小于0
// 并且dp[index][rest - arr[index]] != Integer.MAX_VALUE,因为如果这个位置不能凑出目标数,那就没有比较的必要了
if (rest - arr[index] >= 0
&& dp[index][rest - arr[index]] != Integer.MAX_VALUE) {
// 如果符合条件,就从dp[index + 1][rest](此时dp[index][rest]就等于dp[index + 1][rest])和dp[index][rest - arr[index]]之前找一个最小值,赋值给dp[index][rest]
dp[index][rest] = Math.min(dp[index][rest], dp[index][rest - arr[index]] + 1);
}
}
}
return dp[0][aim] == Integer.MAX_VALUE ? -1 : dp[0][aim];
}
}
三、解题思路
这道题是一个简单的动态规划问题,注意可以使用斜率优化来将枚举行为省略掉。
更多推荐
所有评论(0)